OGRE: Ogre::Light Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::Light Class Reference

Representation of a dynamic light source in the scene. More...

`#include <OgreLight.h>`

Inheritance diagram for Ogre::Light:

[legend]
List of all members.

## Public Types

enum | LightTypes { LT_POINT, LT_DIRECTIONAL, LT_SPOTLIGHT }
| Defines the type of light. More...
typedef std::vector< ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Public Member Functions

void | _calcTempSquareDist (const Vector3 &worldPos)
| internal method for calculating current squared distance from some world position
| Light ()
| Default constructor (for Python mainly).
| Light (const String &name)
| Normal constructor.
| ~Light ()
| Standard destructor.
void | setType (LightTypes type)
| Sets the type of light - see LightTypes for more info.
LightTypes | getType (void) const
| Returns the light type.
void | setDiffuseColour (Real red, Real green, Real blue)
| Sets the colour of the diffuse light given off by this source.
void | setDiffuseColour (const ColourValue &colour)
| Sets the colour of the diffuse light given off by this source.
const ColourValue & | getDiffuseColour (void) const
| Returns the colour of the diffuse light given off by this light source (see setDiffuseColour for more info).
void | setSpecularColour (Real red, Real green, Real blue)
| Sets the colour of the specular light given off by this source.
void | setSpecularColour (const ColourValue &colour)
| Sets the colour of the specular light given off by this source.
const ColourValue & | getSpecularColour (void) const
| Returns the colour of specular light given off by this light source.
void | setAttenuation (Real range, Real constant, Real linear, Real quadratic)
| Sets the attenuation parameters of the light source ie how it diminishes with distance.
Real | getAttenuationRange (void) const
| Returns the absolute upper range of the light.
Real | getAttenuationConstant (void) const
| Returns the constant factor in the attenuation formula.
Real | getAttenuationLinear (void) const
| Returns the linear factor in the attenuation formula.
Real | getAttenuationQuadric (void) const
| Returns the quadric factor in the attenuation formula.
void | setPosition (Real x, Real y, Real z)
| Sets the position of the light.
void | setPosition (const Vector3 &vec)
| Sets the position of the light.
const Vector3 & | getPosition (void) const
| Returns the position of the light.
void | setDirection (Real x, Real y, Real z)
| Sets the direction in which a light points.
void | setDirection (const Vector3 &vec)
| Sets the direction in which a light points.
const Vector3 & | getDirection (void) const
| Returns the light's direction.
void | setSpotlightRange (const Radian &innerAngle, const Radian &outerAngle, Real falloff=1.0)
| Sets the range of a spotlight, i.e.
const Radian & | getSpotlightInnerAngle (void) const
| Returns the angle covered by the spotlights inner cone.
const Radian & | getSpotlightOuterAngle (void) const
| Returns the angle covered by the spotlights outer cone.
Real | getSpotlightFalloff (void) const
| Returns the falloff between the inner and outer cones of the spotlight.
void | setSpotlightInnerAngle (const Radian &val)
| Sets the angle covered by the spotlights inner cone.
void | setSpotlightOuterAngle (const Radian &val)
| Sets the angle covered by the spotlights outer cone.
void | setSpotlightFalloff (Real val)
| Sets the falloff between the inner and outer cones of the spotlight.
void | setPowerScale (Real power)
| Set a scaling factor to indicate the relative power of a light.
Real | getPowerScale (void) const
| Set the scaling factor which indicates the relative power of a light.
void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Overridden from MovableObject.
void | _notifyMoved (void)
| Overridden from MovableObject.
const AxisAlignedBox & | getBoundingBox (void) const
| Overridden from MovableObject.
void | _updateRenderQueue (RenderQueue *queue)
| Overridden from MovableObject.
const String & | getMovableType (void) const
| Overridden from MovableObject.
const Vector3 & | getDerivedPosition (void) const
| Retrieves the position of the light including any transform from nodes it is attached to.
const Vector3 & | getDerivedDirection (void) const
| Retrieves the direction of the light including any transform from nodes it is attached to.
void | setVisible (bool visible)
| Overridden from MovableObject.
Real | getBoundingRadius (void) const
| Overridden from MovableObject.
Vector4 | getAs4DVector (void) const
| Gets the details of this light as a 4D vector.
virtual const PlaneBoundedVolume & | _getNearClipVolume (const Camera *const cam) const
| Internal method for calculating the 'near clip volume', which is the volume formed between the near clip rectangle of the camera and the light.
virtual const PlaneBoundedVolumeList & | _getFrustumClipVolumes (const Camera *const cam) const
| Internal method for calculating the clip volumes outside of the frustum which can be used to determine which objects are casting shadow on the frustum as a whole.
uint32 | getTypeFlags (void) const
| Override to return specific type flag.
AnimableValuePtr | createAnimableValue (const String &valueName)

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

void | setCustomShadowCameraSetup (const ShadowCameraSetupPtr &customShadowSetup)
| Set this light to use a custom shadow camera when rendering texture shadows.
void | resetCustomShadowCameraSetup (void)
| Reset the shadow camera setup to the default.
const ShadowCameraSetupPtr & | getCustomShadowCameraSetup (void) const
| return a pointer to the custom shadow camera setup (null means use SceneManager global version).
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
EdgeData * | getEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
bool | hasEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Define a default implementation of method from ShadowCaster which implements no shadows.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Static Public Member Functions

static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Public Attributes

Real | tempSquareDist
| Temp tag used for sorting.

## Protected Types

typedef std::map< String, StringVector > | AnimableDictionaryMap

## Protected Member Functions

virtual void | update (void) const
| internal method for synchronising with parent node (if any)
const String & | getAnimableDictionaryName (void) const

Remarks:
  Subclasses must override this if they want to support animation of their values.

void | initialiseAnimableDictionary (StringVector &vec) const
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper moethod for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.

## Protected Attributes

LightTypes | mLightType
Vector3 | mPosition
ColourValue | mDiffuse
ColourValue | mSpecular
Vector3 | mDirection
Radian | mSpotOuter
Radian | mSpotInner
Real | mSpotFalloff
Real | mRange
Real | mAttenuationConst
Real | mAttenuationLinear
Real | mAttenuationQuad
Real | mPowerScale
Vector3 | mDerivedPosition
Vector3 | mDerivedDirection
PlaneBoundedVolume | mNearClipVolume
PlaneBoundedVolumeList | mFrustumClipVolumes
bool | mDerivedTransformDirty
| Is the derived transform dirty?
ShadowCameraSetupPtr | mCustomShadowCameraSetup
| Pointer to a custom shadow camera setup.
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.

## Static Protected Attributes

static String | msMovableType
| Shared class-level name for Movable type.
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.

## Detailed Description

Representation of a dynamic light source in the scene.

Remarks:
  Lights are added to the scene like any other object. They contain various parameters like type, position, attenuation (how light intensity fades with distance), colour etc.

  The defaults when a light is created is pure white diffues light, with no attenuation (does not decrease with distance) and a range of 1000 world units.

  Lights are created by using the SceneManager::createLight method. They can subsequently be added to a SceneNode if required to allow them to move relative to a node in the scene. A light attached to a SceneNode is assumed to havea base position of (0,0,0) and a direction of (0,0,1) before modification by the SceneNode's own orientation. If not attached to a SceneNode, the light's position and direction is as set using setPosition and setDirection.

  Remember also that dynamic lights rely on modifying the colour of vertices based on the position of the light compared to an object's vertex normals. Dynamic lighting will only look good if the object being lit has a fair level of tesselation and the normals are properly set. This is particularly true for the spotlight which will only look right on highly tesselated models. In the future OGRE may be extended for certain scene types so an alternative to the standard dynamic lighting may be used, such as dynamic lightmaps.

Definition at line 67 of file OgreLight.h.

## Member Typedef Documentation

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

| Definition at line 206 of file OgreAnimable.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

| Definition at line 127 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

| Definition at line 128 of file OgreShadowCaster.h.

## Member Enumeration Documentation

enum Ogre::Light::LightTypes

Defines the type of light.

Enumeration values:

  LT_POINT | Point light sources give off light equally in all directions, so require only position not direction.
  LT_DIRECTIONAL | Directional lights simulate parallel light beams from a distant source, hence have direction but no position.
  LT_SPOTLIGHT | Spotlights simulate a cone of light from a source so require position and direction, plus extra values for falloff.

Definition at line 76 of file OgreLight.h.

## Constructor & Destructor Documentation

Ogre::Light::Light | ( |  | ) |

| Default constructor (for Python mainly).

Ogre::Light::Light | ( | const String & | name | ) |

| Normal constructor. Should not be called directly, but rather the SceneManager::createLight method should be used.

Ogre::Light::~Light | ( |  | ) |

| Standard destructor.

## Member Function Documentation

void Ogre::Light::_calcTempSquareDist | ( | const Vector3 & | worldPos | ) |

| internal method for calculating current squared distance from some world position

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

| Get an updateable reference to animable value list. Definition at line 232 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

| Get the creator of this object, if any (internal use only). Definition at line 166 of file OgreMovableObject.h.

virtual const PlaneBoundedVolumeList& Ogre::Light::_getFrustumClipVolumes | ( | const Camera *const | cam | ) | const`[virtual]`

Internal method for calculating the clip volumes outside of the frustum which can be used to determine which objects are casting shadow on the frustum as a whole.

Remarks:
  Each of the volumes is a pyramid for a point/spot light and a cuboid for a directional light.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

| Get the manager of this object, if any (internal use only). Definition at line 170 of file OgreMovableObject.h.

virtual const PlaneBoundedVolume& Ogre::Light::_getNearClipVolume | ( | const Camera *const | cam | ) | const`[virtual]`

Internal method for calculating the 'near clip volume', which is the volume formed between the near clip rectangle of the camera and the light.

Remarks:
  This volume is a pyramid for a point/spot light and a cuboid for a directional light. It can used to detect whether an object could be casting a shadow on the viewport. Note that the reference returned is to a shared volume which will be reused across calls to this method.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

| return the full transformation of the parent sceneNode or the attachingPoint node

void Ogre::Light::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false`
| ) | `[virtual]`

| Overridden from MovableObject. Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

| Notify the object of it's creator (internal use only). Definition at line 164 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual, inherited]`

Internal method to notify the object of the camera to be used for the next rendering operation.

Remarks:
  Certain objects may want to do specific processing based on the camera position. This method notifies them incase they wish to do this.

Reimplemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::InstancedGeometry::BatchInstance, Ogre::MovablePlane, Ogre::ParticleSystem, Ogre::SimpleRenderable, and Ogre::StaticGeometry::Region.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

| Notify the object of it's manager (internal use only). Definition at line 168 of file OgreMovableObject.h.

void Ogre::Light::_notifyMoved | ( | void |  | ) | `[virtual]`

| Overridden from MovableObject. Reimplemented from Ogre::MovableObject.

void Ogre::Light::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

| Overridden from MovableObject. Implements Ogre::MovableObject.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 338 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 366 of file OgreMovableObject.h.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

| Internal method for creating a dictionary of animable value names for the class, if it does not already exist. Definition at line 219 of file OgreAnimable.h.

AnimableValuePtr Ogre::Light::createAnimableValue | ( | const String & | valueName | ) | `[virtual]`

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented from Ogre::AnimableObject.

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogenous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, ie the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags
| ) | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

const String& Ogre::Light::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual]`

Remarks:
  Subclasses must override this if they want to support animation of their values.

Reimplemented from Ogre::AnimableObject.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

| Gets a list of animable value names for this object. Definition at line 260 of file OgreAnimable.h. References OGRE_EXCEPT.

Vector4 Ogre::Light::getAs4DVector | ( | void |  | ) | const

Gets the details of this light as a 4D vector.

Remarks:
  Getting details of a light as a 4D vector can be useful for doing general calculations between different light types; for example the vector can represent both position lights (w=1.0f) and directional lights (w=0.0f) and be used in the same calculations.

Real Ogre::Light::getAttenuationConstant | ( | void |  | ) | const

| Returns the constant factor in the attenuation formula.

Real Ogre::Light::getAttenuationLinear | ( | void |  | ) | const

| Returns the linear factor in the attenuation formula.

Real Ogre::Light::getAttenuationQuadric | ( | void |  | ) | const

| Returns the quadric factor in the attenuation formula.

Real Ogre::Light::getAttenuationRange | ( | void |  | ) | const

| Returns the absolute upper range of the light.

const AxisAlignedBox& Ogre::Light::getBoundingBox | ( | void |  | ) | const`[virtual]`

| Overridden from MovableObject. Implements Ogre::MovableObject.

Real Ogre::Light::getBoundingRadius | ( | void |  | ) | const`[virtual]`

| Overridden from MovableObject. Implements Ogre::MovableObject. Definition at line 323 of file OgreLight.h.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether shadow casting is enabled for this object. Implements Ogre::ShadowCaster. Definition at line 442 of file OgreMovableObject.h.

const ShadowCameraSetupPtr& Ogre::Light::getCustomShadowCameraSetup | ( | void |  | ) | const

| return a pointer to the custom shadow camera setup (null means use SceneManager global version).

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist
| ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

| Get the default query flags for all future MovableObject instances. Definition at line 353 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

| Get the default visibility flags for all future MovableObject instances. Definition at line 381 of file OgreMovableObject.h.

const Vector3& Ogre::Light::getDerivedDirection | ( | void |  | ) | const

| Retrieves the direction of the light including any transform from nodes it is attached to.

const Vector3& Ogre::Light::getDerivedPosition | ( | void |  | ) | const

| Retrieves the position of the light including any transform from nodes it is attached to.

const ColourValue& Ogre::Light::getDiffuseColour | ( | void |  | ) | const

| Returns the colour of the diffuse light given off by this light source (see setDiffuseColour for more info).

const Vector3& Ogre::Light::getDirection | ( | void |  | ) | const

Returns the light's direction.

Remarks:
  Applicable only to the spotlight and directional light types.

EdgeData* Ogre::MovableObject::getEdgeList | ( | void |  | ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region. Definition at line 415 of file OgreMovableObject.h.

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light
| ) | const`[protected, inherited]`

| Helper moethod for calculating extrusion distance.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current listener for this object. Definition at line 392 of file OgreMovableObject.h.

const String& Ogre::Light::getMovableType | ( | void |  | ) | const`[virtual]`

| Overridden from MovableObject. Implements Ogre::MovableObject.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

| Returns the name of this object. Reimplemented in Ogre::Camera. Definition at line 173 of file OgreMovableObject.h.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

| Get the distance to extrude for a point/spot light. Implements Ogre::ShadowCaster.

const Vector3& Ogre::Light::getPosition | ( | void |  | ) | const

Returns the position of the light.

Note:
  Applicable to point lights and spotlights only.

Real Ogre::Light::getPowerScale | ( | void |  | ) | const

| Set the scaling factor which indicates the relative power of a light.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the query flags relevant for this object. Definition at line 345 of file OgreMovableObject.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets the distance at which batches are no longer rendered. Definition at line 278 of file OgreMovableObject.h.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

| Gets the queue group for this entity, see setRenderQueueGroup for full details.

ShadowRenderableListIterator Ogre::MovableObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0`
| ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

const ColourValue& Ogre::Light::getSpecularColour | ( | void |  | ) | const

| Returns the colour of specular light given off by this light source.

Real Ogre::Light::getSpotlightFalloff | ( | void |  | ) | const

| Returns the falloff between the inner and outer cones of the spotlight.

const Radian& Ogre::Light::getSpotlightInnerAngle | ( | void |  | ) | const

| Returns the angle covered by the spotlights inner cone.

const Radian& Ogre::Light::getSpotlightOuterAngle | ( | void |  | ) | const

| Returns the angle covered by the spotlights outer cone.

LightTypes Ogre::Light::getType | ( | void |  | ) | const

| Returns the light type.

uint32 Ogre::Light::getTypeFlags | ( | void |  | ) | const`[virtual]`

| Override to return specific type flag. Reimplemented from Ogre::MovableObject.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves the custom user value associated with this object. Definition at line 306 of file OgreMovableObject.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject. Definition at line 290 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the visibility flags relevant for this object. Definition at line 373 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the axis-aligned bounding box for this object in world coordinates. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the worldspace bounding sphere for this object. Reimplemented in Ogre::Entity.

bool Ogre::MovableObject::hasEdgeList | ( | void |  | ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region. Definition at line 417 of file OgreMovableObject.h.

void Ogre::Light::initialiseAnimableDictionary | ( | StringVector & | vec | ) | const`[protected, virtual]`

| Reimplemented from Ogre::AnimableObject.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, and Ogre::StaticGeometry::Region.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 370 of file OgreMovableObject.h.

void Ogre::Light::resetCustomShadowCameraSetup | ( | void |  | ) |

Reset the shadow camera setup to the default.

See also:
  ShadowCameraSetup

void Ogre::Light::setAttenuation | ( | Real | range,
|  | Real | constant,
|  | Real | linear,
|  | Real | quadratic
| ) |

Sets the attenuation parameters of the light source ie how it diminishes with distance.

Remarks:
  Lights normally get fainter the further they are away. Also, each light is given a maximum range beyond which it cannot affect any objects.

  Light attentuation is not applicable to directional lights since they have an infinite range and constant intensity.

  This follows a standard attenuation approach - see any good 3D text for the details of what they mean since i don't have room here!

Parameters:

  | range | The absolute upper range of the light in world units
  | constant | The constant factor in the attenuation formula: 1.0 means never attenuate, 0.0 is complete attenuation
  | linear | The linear factor in the attenuation formula: 1 means attenuate evenly over the distance
  | quadratic | The quadratic factor in the attenuation formula: adds a curvature to the attenuation formula.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 440 of file OgreMovableObject.h.

void Ogre::Light::setCustomShadowCameraSetup | ( | const ShadowCameraSetupPtr & | customShadowSetup | ) |

Set this light to use a custom shadow camera when rendering texture shadows.

Remarks:
  This changes the shadow camera setup for just this light, you can set the shadow camera setup globally using SceneManager::setShadowCameraSetup

See also:
  ShadowCameraSetup

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default query flags for all future MovableObject instances. Definition at line 349 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default visibility flags for all future MovableObject instances. Definition at line 377 of file OgreMovableObject.h.

void Ogre::Light::setDiffuseColour | ( | const ColourValue & | colour | ) |

Sets the colour of the diffuse light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Diffuse light simulates the typical light emenating from light sources and affects the base colour of objects together with ambient light.

void Ogre::Light::setDiffuseColour | ( | Real | red,
|  | Real | green,
|  | Real | blue
| ) |

Sets the colour of the diffuse light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Diffuse light simulates the typical light emenating from light sources and affects the base colour of objects together with ambient light.

void Ogre::Light::setDirection | ( | const Vector3 & | vec | ) |

Sets the direction in which a light points.

Remarks:
  Applicable only to the spotlight and directional light types.

Note:
  This will be overridden if the light is attached to a SceneNode.

void Ogre::Light::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |

Sets the direction in which a light points.

Remarks:
  Applicable only to the spotlight and directional light types.

Note:
  This will be overridden if the light is attached to a SceneNode.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 388 of file OgreMovableObject.h.

void Ogre::Light::setPosition | ( | const Vector3 & | vec | ) |

Sets the position of the light.

Remarks:
  Applicable to point lights and spotlights only.

Note:
  This will be overridden if the light is attached to a SceneNode.

void Ogre::Light::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |

Sets the position of the light.

Remarks:
  Applicable to point lights and spotlights only.

Note:
  This will be overridden if the light is attached to a SceneNode.

void Ogre::Light::setPowerScale | ( | Real | power | ) |

Set a scaling factor to indicate the relative power of a light.

Remarks:
  This factor is only useful in High Dynamic Range (HDR) rendering. You can bind it to a shader variable to take it into account,

See also:
  GpuProgramParameters

Parameters:

  | power | The power rating of this light, default is 1.0.

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 334 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 272 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

Sets the render queue group this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use.

Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

void Ogre::Light::setSpecularColour | ( | const ColourValue & | colour | ) |

Sets the colour of the specular light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Specular light affects the appearance of shiny highlights on objects, and is also dependent on the 'shininess' Material value.

void Ogre::Light::setSpecularColour | ( | Real | red,
|  | Real | green,
|  | Real | blue
| ) |

Sets the colour of the specular light given off by this source.

Remarks:
  Material objects have ambient, diffuse and specular values which indicate how much of each type of light an object reflects. This value denotes the amount and colour of this type of light the light exudes into the scene. The actual appearance of objects is a combination of the two.

  Specular light affects the appearance of shiny highlights on objects, and is also dependent on the 'shininess' Material value.

void Ogre::Light::setSpotlightFalloff | ( | Real | val | ) |

| Sets the falloff between the inner and outer cones of the spotlight.

void Ogre::Light::setSpotlightInnerAngle | ( | const Radian & | val | ) |

| Sets the angle covered by the spotlights inner cone.

void Ogre::Light::setSpotlightOuterAngle | ( | const Radian & | val | ) |

| Sets the angle covered by the spotlights outer cone.

void Ogre::Light::setSpotlightRange | ( | const Radian & | innerAngle,
|  | const Radian & | outerAngle,
|  | Real | falloff = `1.0`
| ) |

Sets the range of a spotlight, i.e.

the angle of the inner and outer cones and the rate of falloff between them.

Parameters:

  | innerAngle | Angle covered by the bright inner cone The inner cone applicable only to Direct3D, it'll always treat as zero in OpenGL.
  | outerAngle | Angle covered by the outer cone
  | falloff | The rate of falloff between the inner and outer cones. 1.0 means a linear falloff, less means slower falloff, higher means faster falloff.

void Ogre::Light::setType | ( | LightTypes | type | ) |

| Sets the type of light - see LightTypes for more info.

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Note:
  This value is shared with setUserObject so don't use both!

Definition at line 302 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

Call this to associate your own custom user object instance with this MovableObject.

Remarks:
  By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link.

Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 362 of file OgreMovableObject.h.

void Ogre::Light::setVisible | ( | bool | visible | ) | `[virtual]`

Overridden from MovableObject.

Remarks:
  Although lights themselves are not 'visible', setting a light to invisible means it no longer affects the scene.

Reimplemented from Ogre::MovableObject.

virtual void Ogre::Light::update | ( | void |  | ) | const`[protected, virtual]`

| internal method for synchronising with parent node (if any)

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos
| ) | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

## Member Data Documentation

Real Ogre::Light::mAttenuationConst`[protected]`

| Definition at line 396 of file OgreLight.h.

Real Ogre::Light::mAttenuationLinear`[protected]`

| Definition at line 397 of file OgreLight.h.

Real Ogre::Light::mAttenuationQuad`[protected]`

| Definition at line 398 of file OgreLight.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

| Hidden because of distance? Definition at line 115 of file OgreMovableObject.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

| Does this object cast shadows? Definition at line 133 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

| Creator of this object (if created by a factory). Definition at line 103 of file OgreMovableObject.h.

ShadowCameraSetupPtr Ogre::Light::mCustomShadowCameraSetup`[mutable, protected]`

| Pointer to a custom shadow camera setup. Definition at line 414 of file OgreLight.h.

Vector3 Ogre::Light::mDerivedDirection`[mutable, protected]`

| Definition at line 403 of file OgreLight.h.

Vector3 Ogre::Light::mDerivedPosition`[mutable, protected]`

| Definition at line 402 of file OgreLight.h.

bool Ogre::Light::mDerivedTransformDirty`[mutable, protected]`

| Is the derived transform dirty? Definition at line 411 of file OgreLight.h.

ColourValue Ogre::Light::mDiffuse`[protected]`

| Definition at line 387 of file OgreLight.h.

Vector3 Ogre::Light::mDirection`[protected]`

| Definition at line 390 of file OgreLight.h.

PlaneBoundedVolumeList Ogre::Light::mFrustumClipVolumes`[mutable, protected]`

| Definition at line 409 of file OgreLight.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

| List of lights for this object. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 141 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

| The last frame that this light list was updated in. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 143 of file OgreMovableObject.h.

LightTypes Ogre::Light::mLightType`[protected]`

| Definition at line 385 of file OgreLight.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

| MovableObject listener - only one allowed (no list) for size & performance reasons. */. Definition at line 138 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

| SceneManager holding this object (if applicable). Definition at line 105 of file OgreMovableObject.h.

String Ogre::MovableObject::mName`[protected, inherited]`

| Name of this object. Reimplemented in Ogre::Camera. Definition at line 101 of file OgreMovableObject.h.

PlaneBoundedVolume Ogre::Light::mNearClipVolume`[mutable, protected]`

| Definition at line 408 of file OgreLight.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

| Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

| node to which this object is attached Definition at line 107 of file OgreMovableObject.h.

Vector3 Ogre::Light::mPosition`[protected]`

| Definition at line 386 of file OgreLight.h.

Real Ogre::Light::mPowerScale`[protected]`

| Definition at line 399 of file OgreLight.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

| Flags determining whether this object is included / excluded from scene queries. Definition at line 123 of file OgreMovableObject.h.

Real Ogre::Light::mRange`[protected]`

| Definition at line 395 of file OgreLight.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

| Does rendering this object disabled by listener? Definition at line 136 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

| The render queue to use when rendering this object. Definition at line 119 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

| Flags whether the RenderQueue's default should be used. Definition at line 121 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

| Static map of class name to list of animable value names. Definition at line 208 of file OgreAnimable.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

| Default query flags. Definition at line 147 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

| Default visibility flags. Definition at line 149 of file OgreMovableObject.h.

String Ogre::Light::msMovableType`[static, protected]`

| Shared class-level name for Movable type. Definition at line 406 of file OgreLight.h.

ColourValue Ogre::Light::mSpecular`[protected]`

| Definition at line 388 of file OgreLight.h.

Real Ogre::Light::mSpotFalloff`[protected]`

| Definition at line 394 of file OgreLight.h.

Radian Ogre::Light::mSpotInner`[protected]`

| Definition at line 393 of file OgreLight.h.

Radian Ogre::Light::mSpotOuter`[protected]`

| Definition at line 392 of file OgreLight.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

| Definition at line 113 of file OgreMovableObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

| Upper distance to still render. Definition at line 112 of file OgreMovableObject.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

| User defined link to another object / value / whatever. Definition at line 117 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

| Flags determining whether this object is visible (compared to SceneManager mask). Definition at line 125 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

| Is this object visible? Definition at line 110 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

| Cached world AABB of this object. Reimplemented in Ogre::ParticleSystem. Definition at line 127 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

| Definition at line 129 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

| World space AABB of this object's dark cap. Definition at line 131 of file OgreMovableObject.h.

Real Ogre::Light::tempSquareDist

| Temp tag used for sorting. Definition at line 71 of file OgreLight.h.

The documentation for this class was generated from the following file:

- OgreLight.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:47:00 2008